import datetime
import pymysql
import pandas as pd


def doctor():
    date_str = (datetime.datetime.now() - datetime.timedelta(days=1)).strftime("%Y%m%d")
    date_tmp = (datetime.datetime.now() - datetime.timedelta(days=1)).strftime("%Y-%m-%d")
    # sql = "select distinct doctor_id from statistic_doctor_rank_factor where partition_date = '{}'".format(date_str)
    # doctor_list = pd.DataFrame(list(result))[0].values.tolist()

    sql = "select d.doctor_id,d.service_exposure_pv_30,d.service_ctr_30,d.expert_exposure_pv_30,d.expert_pv_30," \
    "b.merchant_id," \
    "m.doctor_ad_money_30_days,m.expand_rechange_amount_30,m.service_pv_30,m.expert_pv_30,m.organization_pv_30," \
    "budan.budan_payment_30_days " \
    "from statistic_doctor_rank_factor d " \
    "left join hippo_merchantrelevance b on d.doctor_id = b.doctor_id " \
    "left join statistic_merchant_rank_factor m on b.merchant_id = m.merchant_id " \
    "left join al_meigou_service_smart_rank_budan_payment budan on b.merchant_id = budan.merchant_id " \
    "where d.partition_date = '{}' and m.partition_date = '{}' " \
    "and budan.stat_date = '{}';".format(date_str,date_str,date_tmp)

    db = pymysql.connect(host='172.16.30.143', port=3306, user='work', passwd='BJQaT9VzDcuPBqkd', db='zhengxing')
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    df = pd.DataFrame(list(result))

    name = ["doctor_id","service_exposure_pv_30","service_ctr_30","expert_exposure_pv_30","expert_pv_30",
            "merchant_id","doctor_ad_money_30_days","expand_rechange_amount_30","service_pv_30",
            "mexpert_pv_30","organization_pv_30","budan_payment_30_days"]

    df = df.rename(columns=dict(zip(list(range(len(name))),name)))
    for i in ["service_exposure_pv_30", "service_ctr_30", "expert_exposure_pv_30", "expert_pv_30",
      "doctor_ad_money_30_days", "expand_rechange_amount_30", "service_pv_30",
     "mexpert_pv_30", "organization_pv_30", "budan_payment_30_days"]:
        df[i] = df[i].astype("float")

    df["all_exposure"] = df["service_exposure_pv_30"] + df["expert_exposure_pv_30"]
    df = df[~df["expert_exposure_pv_30"].isin([0.0])]
    df = df[~df["all_exposure"].isin([0.0])]
    df["tmp"] = df["service_pv_30"] + df["mexpert_pv_30"] +df["organization_pv_30"]
    df = df[~df["tmp"].isin([0.0])]

    df["ctr"] = df["service_exposure_pv_30"] / df["all_exposure"] * df["service_ctr_30"] + \
                df["expert_exposure_pv_30"]/df["all_exposure"] * (df["expert_pv_30"] / df["expert_exposure_pv_30"])
    df["commission"] = (df["doctor_ad_money_30_days"] + df["budan_payment_30_days"])/df["tmp"]
    df["pv_ad"] = df["expand_rechange_amount_30"]/df["tmp"]
    df["score"] = df["ctr"]**0.5 * (df["commission"] + df["pv_ad"])
    columns = ["score","ctr","commission","pv_ad","service_exposure_pv_30","service_ctr_30","expert_exposure_pv_30","expert_pv_30",
            "merchant_id","doctor_ad_money_30_days","expand_rechange_amount_30","service_pv_30",
            "mexpert_pv_30","organization_pv_30","budan_payment_30_days"]
    data = df.loc[:, columns]
    # print(data)
    data.to_csv('/home/gmuser/doctor.csv',index=False)


def v1_doctor():
    date_str = (datetime.datetime.now() - datetime.timedelta(days=1)).strftime("%Y%m%d")
    date_tmp = (datetime.datetime.now() - datetime.timedelta(days=1)).strftime("%Y-%m-%d")

    sql = "select d.doctor_id,d.service_exposure_pv_30,d.service_ctr_30,d.expert_exposure_pv_30,d.expert_pv_30," \
    "b.merchant_id,budan.budan_payment_30_days " \
          "from statistic_doctor_rank_factor d " \
    "left join hippo_merchantrelevance b on d.doctor_id = b.doctor_id " \
    "left join al_meigou_service_smart_rank_budan_payment budan on b.merchant_id = budan.merchant_id " \
    "where d.partition_date = '{}' and budan.stat_date = '{}';".format(date_str, date_tmp)

    db = pymysql.connect(host='172.16.30.143', port=3306, user='work', passwd='BJQaT9VzDcuPBqkd', db='zhengxing')
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    df = pd.DataFrame(list(result))
    name = ["doctor_id", "service_exposure_pv_30", "service_ctr_30", "expert_exposure_pv_30", "expert_pv_30",
            "merchant_id","budan_payment_30_days"]

    df = df.rename(columns=dict(zip(list(range(len(name))), name)))

    sql = "select merchant_id,doctor_ad_money_30_days,expand_rechange_amount_30," \
          "service_pv_30,expert_pv_30,organization_pv_30 from statistic_merchant_rank_factor " \
          "where partition_date = '{}';".format(date_str)

    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    db.close()
    tmp = pd.DataFrame(list(result))
    name = ["merchant_id", "doctor_ad_money_30_days", "expand_rechange_amount_30", "service_pv_30",
            "mexpert_pv_30", "organization_pv_30"]
    tmp = tmp.rename(columns=dict(zip(list(range(len(name))), name)))

    df["merchant_id"] = df["merchant_id"].astype("str")
    tmp["merchant_id"] = tmp["merchant_id"].astype("str")
    df = pd.merge(df, tmp, on='merchant_id')

    for i in ["service_exposure_pv_30", "service_ctr_30", "expert_exposure_pv_30", "expert_pv_30",
      "doctor_ad_money_30_days", "expand_rechange_amount_30", "service_pv_30",
     "mexpert_pv_30", "organization_pv_30", "budan_payment_30_days"]:
        df[i] = df[i].astype("float")

    df["all_exposure"] = df["service_exposure_pv_30"] + df["expert_exposure_pv_30"]
    df = df[~df["expert_exposure_pv_30"].isin([0.0])]
    df = df[~df["all_exposure"].isin([0.0])]
    df["tmp"] = df["service_pv_30"] + df["mexpert_pv_30"] +df["organization_pv_30"]
    df = df[~df["tmp"].isin([0.0])]
    print("aaaaaaaa")
    df["ctr"] = df["service_exposure_pv_30"] / df["all_exposure"] * df["service_ctr_30"] + \
                df["expert_exposure_pv_30"]/df["all_exposure"] * (df["expert_pv_30"] / df["expert_exposure_pv_30"])
    df["commission"] = (df["doctor_ad_money_30_days"] + df["budan_payment_30_days"])/df["tmp"]
    df["pv_ad"] = df["expand_rechange_amount_30"]/df["tmp"]
    df["score"] = df["ctr"]**0.5 * (df["commission"] + df["pv_ad"])
    columns = ["score","ctr","commission","pv_ad","service_exposure_pv_30","service_ctr_30","expert_exposure_pv_30","expert_pv_30",
            "merchant_id","doctor_ad_money_30_days","expand_rechange_amount_30","service_pv_30",
            "mexpert_pv_30","organization_pv_30","budan_payment_30_days"]
    data = df.loc[:, columns]
    print(data.head(6))
    data.to_csv('/home/gmuser/doctor.csv',index=False)


def hospital():
    date_str = (datetime.datetime.now() - datetime.timedelta(days=1)).strftime("%Y%m%d")
    date_tmp = (datetime.datetime.now() - datetime.timedelta(days=1)).strftime("%Y-%m-%d")

    sql = "select api.id," \
          "h.hospital_id,h.hospital_exposure_pv_30,h.service_exposure_pv_30,h.expert_exposure_pv_30," \
          "h.service_ctr_30,h.hospital_ctr_30,h.expert_ctr_30," \
          "b.merchant_id,budan.budan_payment_30_days " \
          "from api_doctor api left join statistic_hospital_rank_factor h on api.hospital_id = h.hospital_id " \
          "left join hippo_merchantrelevance b on api.id = b.doctor_id " \
          "left join al_meigou_service_smart_rank_budan_payment budan on b.merchant_id = budan.merchant_id " \
          "where api.doctor_type = 1 and h.date = '{}' " \
          "and budan.stat_date = '{}' limit 6;".format(date_str, date_tmp)

    db = pymysql.connect(host='172.16.30.143', port=3306, user='work', passwd='BJQaT9VzDcuPBqkd', db='zhengxing')
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    df = pd.DataFrame(list(result))
    name = ["doctor_id","hospital_id","hospital_exposure_pv_30","service_exposure_pv_30",
            "expert_exposure_pv_30","service_ctr_30","hospital_ctr_30","expert_ctr_30","merchant_id",
            "budan_payment_30_days"]

    df = df.rename(columns=dict(zip(list(range(len(name))), name)))

    print(df.head(6))

    sql = "select merchant_id,doctor_ad_money_30_days," \
          "service_pv_30,expert_pv_30,organization_pv_30,doctor_discount_30_days from statistic_merchant_rank_factor " \
          "where partition_date = '{}' limit 6;".format(date_str)

    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    db.close()
    tmp = pd.DataFrame(list(result))
    name = ["merchant_id", "doctor_ad_money_30_days", "expand_rechange_amount_30", "service_pv_30",
            "mexpert_pv_30", "organization_pv_30","doctor_discount_30_days"]
    tmp = tmp.rename(columns=dict(zip(list(range(len(name))), name)))
    print(tmp.head(6))

    # df["merchant_id"] = df["merchant_id"].astype("str")
    # tmp["merchant_id"] = tmp["merchant_id"].astype("str")
    # df = pd.merge(df, tmp, on='merchant_id')
    #
    # for i in ["hospital_exposure_pv_30","service_exposure_pv_30","expert_exposure_pv_30",
    #           "service_ctr_30","hospital_ctr_30","expert_ctr_30",
    #           "doctor_ad_money_30_days", "service_pv_30",
    #           "mexpert_pv_30", "organization_pv_30", "budan_payment_30_days","doctor_discount_30_days"]:
    #     df[i] = df[i].astype("float")
    #
    # df["all_exposure"] = df["hospital_exposure_pv_30"] + df["service_exposure_pv_30"] + df["expert_exposure_pv_30"]
    # df = df[~df["all_exposure"].isin([0.0])]
    # df["tmp"] = df["service_pv_30"] + df["mexpert_pv_30"] +df["organization_pv_30"]
    # df = df[~df["tmp"].isin([0.0])]
    # print("aaaaaaaa")
    # df["ctr"] = df["service_exposure_pv_30"] / df["all_exposure"] * df["service_ctr_30"] + \
    #             df["hospital_exposure_pv_30"]/ df["all_exposure"] * df["hospital_ctr_30"] + \
    #             df["expert_exposure_pv_30"]/df["all_exposure"] * df["expert_ctr_30"]
    # df["commission"] = (df["doctor_ad_money_30_days"] + df["budan_payment_30_days"])/df["tmp"]
    # df["cpt"] = df["doctor_discount_30_days"]/df["tmp"]
    # df["score"] = df["ctr"]**0.5 * (df["commission"] + df["cpt"])
    # columns = ["score","ctr","commission","cpt","hospital_exposure_pv_30","service_exposure_pv_30",
    #            "expert_exposure_pv_30",
    #           "service_ctr_30","hospital_ctr_30","expert_ctr_30", "service_pv_30",
    #           "mexpert_pv_30", "organization_pv_30"]
    # data = df.loc[:, columns]
    # print(data.head(6))
    # data.to_csv('/home/gmuser/hospital.csv',index=False)

if __name__ == "__main__":
    hospital()

